import * as Promise from 'bluebird';
import { Action, Dispatch } from 'pretur.redux';
import { Query, Synchronizer, Fetcher } from 'pretur.sync';
import Querier from './query/Querier';
import Set from './data/Set';
import UniqueReducible from './UniqueReducible';
export default class Reactive<T extends Set<any, any, any>> extends UniqueReducible {
    private _set;
    private _querier;
    private _initialized;
    private _buildFetcher;
    constructor(set: T, query: Query, buildFetcher?: () => Fetcher);
    set: T;
    querier: Querier;
    initialized: boolean;
    valid: boolean;
    reduce(action: Action<any, any>): this;
    init(dispatch: Dispatch, fetcher: Fetcher): Promise<void>;
    initIfNeeded(dispatch: Dispatch, fetcher: Fetcher): void;
    forceRefresh(dispatch: Dispatch, fetcher: Fetcher): Promise<void>;
    ensureValidity(dispatch: Dispatch): boolean;
    ensureValidityAndSync(dispatch: Dispatch, synchronizer: Synchronizer, autoDecay?: boolean, autoRefresh?: boolean): boolean;
    protected cloneOverride(clone: this): void;
    protected createInstance(): this;
}
