"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require('../UniqueReducible');
var actions_1 = require('./actions');
var Filterer = (function (_super) {
    __extends(Filterer, _super);
    function Filterer(filters) {
        var _this = this;
        _super.call(this);
        if (filters) {
            this._filters = {};
            Object.keys(filters).forEach(function (key) {
                _this._filters[key] = filters[key];
            });
        }
    }
    Object.defineProperty(Filterer.prototype, "filters", {
        get: function () {
            return this._filters || {};
        },
        enumerable: true,
        configurable: true
    });
    Filterer.prototype.get = function (field) {
        if (!this._filters) {
            return;
        }
        return this._filters[field];
    };
    Object.defineProperty(Filterer.prototype, "plain", {
        get: function () {
            var _this = this;
            if (!this._filters) {
                return null;
            }
            var keys = Object.keys(this._filters);
            if (keys.length === 0) {
                return null;
            }
            var filters = {};
            keys.forEach(function (key) {
                filters[key] = _this._filters[key];
            });
            return filters;
        },
        enumerable: true,
        configurable: true
    });
    Filterer.prototype.reduce = function (action) {
        if (actions_1.CLAY_QUERY_SET_FILTERS.is(this.id, action)) {
            var clone = this.clone();
            clone._filters = action.payload;
            return clone;
        }
        return this;
    };
    Filterer.prototype.setAll = function (dispatch, filters) {
        var _this = this;
        var newFilters = {};
        if (this._filters) {
            Object.keys(this._filters).forEach(function (key) {
                newFilters[key] = _this._filters[key];
            });
        }
        dispatch(actions_1.CLAY_QUERY_SET_FILTERS.create.unicast(this.id, filters));
    };
    Filterer.prototype.setFilter = function (dispatch, field, filter) {
        var _this = this;
        var newFilters = {};
        if (this._filters) {
            Object.keys(this._filters).forEach(function (key) {
                newFilters[key] = _this._filters[key];
            });
        }
        newFilters[field] = filter;
        dispatch(actions_1.CLAY_QUERY_SET_FILTERS.create.unicast(this.id, newFilters));
    };
    Filterer.prototype.clearFilter = function (dispatch, field) {
        var _this = this;
        var newFilters = {};
        if (this._filters) {
            Object.keys(this._filters).forEach(function (key) {
                newFilters[key] = _this._filters[key];
            });
        }
        delete newFilters[field];
        dispatch(actions_1.CLAY_QUERY_SET_FILTERS.create.unicast(this.id, newFilters));
    };
    Filterer.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._filters = this._filters;
    };
    Filterer.prototype.createInstance = function () {
        return new Filterer();
    };
    return Filterer;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Filterer;
