"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require('../UniqueReducible');
var actions_1 = require('./actions');
var Orderer = (function (_super) {
    __extends(Orderer, _super);
    function Orderer(order) {
        _super.call(this);
        this._ordering = 'NONE';
        if (order) {
            this._field = order.field;
            this._ordering = order.ordering;
            this._chain = order.chain;
        }
    }
    Object.defineProperty(Orderer.prototype, "field", {
        get: function () {
            return this._field;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Orderer.prototype, "ordering", {
        get: function () {
            return this._ordering;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Orderer.prototype, "chain", {
        get: function () {
            return this._chain;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Orderer.prototype, "plain", {
        get: function () {
            if (!this._field) {
                return null;
            }
            var order = {
                field: this._field,
                ordering: this._ordering,
            };
            if (Array.isArray(this._chain)) {
                order.chain = this._chain.slice();
            }
            return order;
        },
        enumerable: true,
        configurable: true
    });
    Orderer.prototype.reduce = function (action) {
        if (actions_1.CLAY_QUERY_SET_ORDER.is(this.id, action)) {
            var clone = this.clone();
            clone._field = action.payload.field;
            clone._ordering = action.payload.ordering;
            clone._chain = action.payload.chain;
            return clone;
        }
        return this;
    };
    Orderer.prototype.set = function (dispatch, field, ordering, chain) {
        if (typeof ordering !== 'string') {
            if (this.field !== field) {
                ordering = 'NONE';
            }
            else {
                switch (this.ordering) {
                    case 'NONE':
                        ordering = 'ASC';
                        break;
                    case 'ASC':
                        ordering = 'DESC';
                        break;
                    default:
                        ordering = 'NONE';
                        break;
                }
            }
        }
        dispatch(actions_1.CLAY_QUERY_SET_ORDER.create.unicast(this.id, { field: field, ordering: ordering, chain: chain }));
    };
    Orderer.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._field = this._field;
        clone._ordering = this._ordering;
        clone._chain = this._chain;
    };
    Orderer.prototype.createInstance = function () {
        return new Orderer();
    };
    return Orderer;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Orderer;
