"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require('../UniqueReducible');
var actions_1 = require('./actions');
var Paginator = (function (_super) {
    __extends(Paginator, _super);
    function Paginator(pagination) {
        _super.call(this);
        if (pagination) {
            this._skip = pagination.skip;
            this._take = pagination.take;
        }
    }
    Object.defineProperty(Paginator.prototype, "skip", {
        get: function () {
            return this._skip;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "take", {
        get: function () {
            return this._take;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "plain", {
        get: function () {
            if (typeof this._skip !== 'number' && typeof this._take !== 'number') {
                return null;
            }
            var pagination = {};
            if (typeof this._skip === 'number') {
                pagination.skip = this._skip;
            }
            if (typeof this._take === 'number') {
                pagination.take = this._take;
            }
            return pagination;
        },
        enumerable: true,
        configurable: true
    });
    Paginator.prototype.reduce = function (action) {
        if (actions_1.CLAY_QUERY_SET_PAGINATION.is(this.id, action)) {
            var clone = this.clone();
            clone._skip = action.payload.skip;
            clone._take = action.payload.take;
            return clone;
        }
        return this;
    };
    Paginator.prototype.set = function (dispatch, skip, take) {
        dispatch(actions_1.CLAY_QUERY_SET_PAGINATION.create.unicast(this.id, { skip: skip, take: take }));
    };
    Paginator.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._skip = this._skip;
        clone._take = this._take;
    };
    Paginator.prototype.createInstance = function () {
        return new Paginator();
    };
    return Paginator;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Paginator;
