"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require('../UniqueReducible');
var Includer_1 = require('./Includer');
var Filterer_1 = require('./Filterer');
var Attributor_1 = require('./Attributor');
var Paginator_1 = require('./Paginator');
var SubQuerier = (function (_super) {
    __extends(SubQuerier, _super);
    function SubQuerier(subquery) {
        _super.call(this);
        if (subquery === null) {
            this._model = subquery.model;
            this._includer = new Includer_1.default(subquery.include);
            this._filterer = new Filterer_1.default(subquery.filters);
            this._attributor = new Attributor_1.default(subquery.attributes);
            this._paginator = new Paginator_1.default(subquery.pagination);
        }
    }
    Object.defineProperty(SubQuerier.prototype, "model", {
        get: function () {
            return this._model;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "includer", {
        get: function () {
            return this._includer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "filterer", {
        get: function () {
            return this._filterer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "attributor", {
        get: function () {
            return this._attributor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "paginator", {
        get: function () {
            return this._paginator;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "plain", {
        get: function () {
            var subquery = {};
            subquery.model = this._model;
            var include = this._includer.plain;
            if (include !== null) {
                subquery.include = include;
            }
            var filters = this._filterer.plain;
            if (filters !== null) {
                subquery.filters = filters;
            }
            var attributes = this._attributor.plain;
            if (attributes !== null) {
                subquery.attributes = attributes;
            }
            var pagination = this._paginator.plain;
            if (pagination !== null) {
                subquery.count = true;
                subquery.pagination = pagination;
            }
            return subquery;
        },
        enumerable: true,
        configurable: true
    });
    SubQuerier.prototype.reduce = function (action) {
        var includer = this._includer.reduce(action);
        var filterer = this._filterer.reduce(action);
        var attributor = this._attributor.reduce(action);
        var paginator = this._paginator.reduce(action);
        if (includer !== this._includer ||
            filterer !== this._filterer ||
            attributor !== this._attributor ||
            paginator !== this._paginator) {
            var clone = this.clone();
            clone._includer = includer;
            clone._filterer = filterer;
            clone._attributor = attributor;
            clone._paginator = paginator;
            return clone;
        }
        return this;
    };
    SubQuerier.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._model = this._model;
        clone._includer = this._includer;
        clone._filterer = this._filterer;
        clone._attributor = this._attributor;
        clone._paginator = this._paginator;
    };
    SubQuerier.prototype.createInstance = function () {
        return new SubQuerier(null);
    };
    return SubQuerier;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = SubQuerier;
